## org.apache.commons.collections.list
Class TransformedList

    java.lang.Object
      org.apache.commons.collections.collection.AbstractCollectionDecorator
          org.apache.commons.collections.collection.AbstractSerializableCollectionDecorator
              org.apache.commons.collections.collection.TransformedCollection
                  org.apache.commons.collections.list.TransformedList

All Implemented Interfaces:
  Collection, List, Serializable

public class TransformedList
extends TransformedCollection
implements List

Decorates another `List` to transform objects that are added.

The add and set methods are affected by this class. Thus objects must be removed or searched for using their transformed form. For example, if the transformation converts Strings to Integers, you must use the Integer form to remove objects.

This class is Serializable from Commons Collections 3.1.

Since:
  Commons Collections 3.0
Version:
  $Revision: 1.5 $ $Date: 2004/06/03 22:02:13 $
Author:
  Stephen Colebourne
See Also:
  Serialized Form

Nested Class Summary
`protected class` `TransformedList.TransformedListIterator` Inner class Iterator for the TransformedList

Field Summary

Fields inherited from class org.apache.commons.collections.collection.TransformedCollection
`transformer`

Fields inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`collection`

Constructor Summary
`protected` `TransformedList(List list, Transformer transformer)` Constructor that wraps (not copies).

Method Summary
`void` `add(int index, Object object)`
`boolean` `addAll(int index, Collection coll)`
`static List` `decorate(List list, Transformer transformer)` Factory method to create a transforming list.
`Object` `get(int index)`
`protected List` `getList()` Gets the decorated list.
`int` `indexOf(Object object)`
`int` `lastIndexOf(Object object)`
`ListIterator` `listIterator()`
`ListIterator` `listIterator(int i)`
`Object` `remove(int index)`
`Object` `set(int index, Object object)`
`List` `subList(int fromIndex, int toIndex)`

Methods inherited from class org.apache.commons.collections.collection.TransformedCollection
`add, addAll, decorate, transform, transform`

Methods inherited from class org.apache.commons.collections.collection.AbstractCollectionDecorator
`clear, contains, containsAll, equals, getCollection, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.List
`add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, toArray, toArray`

Constructor Detail

### TransformedList

    protected TransformedList(List list,
                              Transformer transformer)

  Constructor that wraps (not copies).

  If there are any elements already in the list being decorated, they are NOT transformed.

Parameters:
  `list` - the list to decorate, must not be null
  `transformer` - the transformer to use for conversion, must not be null
Throws:
  `IllegalArgumentException` - if list or transformer is null

Method Detail

### decorate

    public static List decorate(List list,
                                Transformer transformer)

  Factory method to create a transforming list.

  If there are any elements already in the list being decorated, they are NOT transformed.

  Parameters:
    `list` - the list to decorate, must not be null
    `transformer` - the transformer to use for conversion, must not be null
  Throws:
    `IllegalArgumentException` - if list or transformer is null

### getList

    protected List getList()

  Gets the decorated list.

  Returns:
    the decorated list

### get

    public Object get(int index)

  Specified by:
    `get` in interface `List`

### indexOf

    public int indexOf(Object object)

  Specified by:
    `indexOf` in interface `List`

### lastIndexOf

    public int lastIndexOf(Object object)

  Specified by:
    `lastIndexOf` in interface `List`

### remove

    public Object remove(int index)

  Specified by:
    `remove` in interface `List`

### add

    public void add(int index,
                    Object object)

  Specified by:
    `add` in interface `List`

### addAll

    public boolean addAll(int index,
                          Collection coll)

  Specified by:
    `addAll` in interface `List`

### listIterator

    public ListIterator listIterator()

  Specified by:
    `listIterator` in interface `List`

### listIterator

    public ListIterator listIterator(int i)

  Specified by:
    `listIterator` in interface `List`

### set

    public Object set(int index,
                      Object object)

  Specified by:
    `set` in interface `List`

### subList

    public List subList(int fromIndex,
                        int toIndex)

  Specified by:
    `subList` in interface `List`

Copyright © 2001-2005 Apache Software Foundation. All Rights Reserved.